package com.gcotu_ootp.obsrecordingdetector;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;




final class FileWithDate implements Comparable<FileWithDate> {


    public static boolean detectIfOBSHasFileUnderLockAndKey(final FileWithDate newestFILE) {

        final Path original = newestFILE.file.toPath();
        final Path changed = new File(newestFILE.file.getParent(), newestFILE.file.getName() + "_").toPath();
        try {
            Files.move(original, changed);
            try {
                Files.move(changed, original);
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
            return false;
        } catch (IOException e) {
            return true;
        }


        // *** NONE OF THESE WORK *** (Maybe even be related to the chosen video file type and thus to the way it's written by OBS.)
        //                if (newestFILE.file.canWrite()) {
        //                    System.err.println(newestFILE + "\t\tStopped.");
        //                }else {
        //                    System.err.println(newestFILE + "RECORDING!");
        //                }
        //                try (final RandomAccessFile raf = new RandomAccessFile(newestFILE.file, "rw")) {//"rws")) {
        //                    System.err.println(newestFILE + "\t\tStopped.");
        //                } catch (IOException e) {
        //                    System.err.println(newestFILE + "RECORDING!");
        //                }
        //                try (final BufferedReader br = Files.newBufferedReader(newestFILE.file.toPath(), StandardCharsets.UTF_8)) {
        //                    System.err.println(newestFILE + "\t\tStopped.");
        //                } catch (IOException e) {
        //                    System.err.println(newestFILE + "RECORDING!");
        //                }

    }


    public static FileWithDate identifyNewestFile(final File folder) {

        final File[] files = folder.listFiles();
        if (files == null) {
            System.err.println("Folder can currently not be read: " + folder);
            return null;
        }

        final List<FileWithDate> filesSorted = new ArrayList<>();
        for (File f : files) {
            filesSorted.add(new FileWithDate(f));
        }
        filesSorted.sort(null);
        for (FileWithDate fileWithDate : filesSorted) {
            if (fileWithDate.file.isFile()) {
                return fileWithDate;
            }
        }
        return null;
    }


    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


    final public File file;
    final public long lastModified;


    public FileWithDate(final File file) {

        this.file = file;
        lastModified = file.lastModified();
    }


    @Override
    public int compareTo(final FileWithDate o) {

        return Long.compare(o.lastModified, lastModified); // Swapped. Meaning: DESCENDING.
    }


    public String toString() {

        return lastModified + "\t\t" + file.getName();
    }


    /**
     * DOES NOT consider the date modified! This is important for the overall OBS paused/recording detection concept.
     */
    @Override
    public boolean equals(final Object o) {

        return this == o || (o instanceof FileWithDate && file.equals(((FileWithDate) o).file));
    }


    @Override
    public int hashCode() {

        return Objects.hash(file);
    }
}
