package com.gcotu_ootp.obsrecordingdetector;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;




final public class ImageHandler {


    final private static String IMGFN_STOPPED = "OBSRECORDINGINDICATOR_stopped.png";
    final private static String IMGFN_RECORDING = "OBSRECORDINGINDICATOR_recording.png";
    final private static String IMGFN_PAUSED = "OBSRECORDINGINDICATOR_paused.png";

    final private File file_stopped;
    final private File file_recording;
    final private File file_paused;

    private BufferedImage img_stopped = null;
    private BufferedImage img_recording = null;
    private BufferedImage img_paused = null;

    public ImageHandler(final File folder) {

        file_stopped = new File(folder, IMGFN_STOPPED);
        file_recording = new File(folder, IMGFN_RECORDING);
        file_paused = new File(folder, IMGFN_PAUSED);
    }


    public BufferedImage getImage(final Boolean recording_nullNo_falsePause_trueYes) {

        if (recording_nullNo_falsePause_trueYes == null) {
            return img_stopped;
        } else if (recording_nullNo_falsePause_trueYes) {
            return img_recording;
        } else {
            return img_paused;
        }
    }


    public void loadImages() {

        img_stopped = loadImage(file_stopped);
        img_recording = loadImage(file_recording);
        img_paused = loadImage(file_paused);
    }


    private BufferedImage loadImage(final File file) {

        if (!file.isFile()) {
            System.err.println("Image file does not exist: " + file);
            System.exit(-1);
        }

        try {
            return ImageIO.read(file);
        } catch (IOException e) {
            System.err.println("Error loading image file \"" + file + "\": " + e.getMessage());
            System.exit(-1);
            throw new Error();
        }
    }


    public void printImageFileNames() {

        System.err.println();
        System.err.println("The following image files will be loaded - THEY HAVE TO EXIST:");
        System.err.println(file_stopped);
        System.err.println(file_recording);
        System.err.println(file_paused);
        System.err.println();
    }
}
